package calc;


/** Represents a Variable in the Calc-Scheme. Variables are (like Numerals)
    leaves in the operation tree, therefore they simply return the value 
    which was set in setValue() */

public class VariableCalc extends BaseCalc {

  boolean sign = true;
  public int getArgsNr(){
    return 1;
  }

  /** set the value of the variable. This method is called for every element
      of the definition lattice, when the Values are calculated */
  public void setValue(Complex value){
    if(sign == false)
      value.negate();
    result = value;
  }

  /** Returns the sign of the variable true means positive value, false 
      negative */
  public boolean getSign(){
    return sign;
  }

  /** used by ExprParser if "-t" is encountered */
  public void setSign(boolean inSign){
    sign = inSign;
    //System.out.println("sign is now:"+sign);
  }

  /* Keep the argument as the result */
  public VariableCalc(){
    calculated = true;
    result = new Complex(0,0);
  }

  public String getArithmeticSymbol(){
    if(sign)
      return "t";
    else
      return "-t";
  }

  /** does nothing, since the result is already set in Constructor */
  protected void doCalculate(){
  }
    
}
	


